# Submariner Operator

<!-- markdownlint-disable line-length -->
[![End to End Tests](https://github.com/submariner-io/submariner-operator/workflows/End%20to%20End%20Tests/badge.svg)](https://github.com/submariner-io/submariner-operator/actions?query=workflow%3A%22End+to+End+Tests%22)
[![Unit Tests](https://github.com/submariner-io/submariner-operator/workflows/Unit%20Tests/badge.svg)](https://github.com/submariner-io/submariner-operator/actions?query=workflow%3A%22Unit+Tests%22)
[![Linting](https://github.com/submariner-io/submariner-operator/workflows/Linting/badge.svg)](https://github.com/submariner-io/submariner-operator/actions?query=workflow%3ALinting)
[![Prometheus Tests](https://github.com/submariner-io/submariner-operator/workflows/Prometheus%20Tests/badge.svg)](https://github.com/submariner-io/submariner-operator/actions?query=workflow%3A%22Prometheus+Tests%22)
[![Release Images](https://github.com/submariner-io/submariner-operator/workflows/Release%20Images/badge.svg)](https://github.com/submariner-io/submariner-operator/actions?query=workflow%3A%22Release+Images%22)
[![Upgrade](https://github.com/submariner-io/submariner-operator/workflows/Upgrade/badge.svg)](https://github.com/submariner-io/submariner-operator/actions?query=workflow%3AUpgrade)
[![Periodic](https://github.com/submariner-io/submariner-operator/workflows/Periodic/badge.svg)](https://github.com/submariner-io/submariner-operator/actions?query=workflow%3APeriodic)
[![Flake Finder](https://github.com/submariner-io/submariner-operator/workflows/Flake%20Finder/badge.svg)](https://github.com/submariner-io/submariner-operator/actions?query=workflow%3A%22Flake+Finder%22)
<!-- markdownlint-enable line-length -->

The Submariner Operator installs the Submariner components on a Kubernetes cluster. It's also available on
[OperatorHub](https://operatorhub.io/operator/submariner).

## Quickstart

Please refer the Quickstart Guides on Submariner's website:

* [Sandbox Environment (kind)](https://submariner.io/getting-started/quickstart/kind/).
* [OpenShift on AWS](https://submariner.io/getting-started/quickstart/openshift/aws/).
* [OpenShift on AWS with Globalnet](https://submariner.io/getting-started/quickstart/openshift/globalnet/).
* [OpenShift on AWS and vSphere](https://submariner.io/getting-started/quickstart/openshift/vsphere-aws/).
* [Google Kubernetes Engine](https://submariner.io/getting-started/quickstart/managed-kubernetes/gke/).
* [Rancher](https://submariner.io/getting-started/quickstart/managed-kubernetes/rancher/).

## Subctl Releases

### Latest Stable Release

This release has the latest stable binaries: [latest release](https://github.com/submariner-io/submariner-operator/releases/latest).

### Latest Merged Release

This release is constantly updated with the latest code, and might be unstable: [devel
release](https://github.com/submariner-io/submariner-operator/releases/tag/subctl-devel).

## Building and Testing

See the [Building and Testing docs on Submariner's website](https://submariner.io/development/building-testing/).

## Updating OperatorHub

The OperatorHub definitions can be found here:
<!-- markdownlint-disable line-length -->
* [upstream-community-operators/submariner](https://github.com/operator-framework/community-operators/tree/master/upstream-community-operators/submariner)
<!-- markdownlint-enable line-length -->
